#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>

#include <powrprof.h>
#define LAP_MAX 10

#define WINDOW_CLASS "bClock"
#define ADJUST_WINDOW_CLASS "CPUAdjust"

#define IDM_CPUSTATE 4096
#define NI_CLICK ( WM_USER + 0 )

struct LAP{
	ULARGE_INTEGER clk;
	unsigned long int tm;
};

struct LAPTIMES{
	CRITICAL_SECTION lock;
	struct LAP item[ LAP_MAX ];
	int cur;
	int start;
};

extern struct LAPTIMES vLaps;

int ll2str(unsigned long hi, unsigned long lo, char *buf, int len);
#pragma aux ll2str "ll2str" parm routine [ECX] [EDX];

void lladd(ULARGE_INTEGER *a, ULARGE_INTEGER *b);
#pragma aux lladd "lladd" parm routine [EAX] [EDX];

void lladdim(ULARGE_INTEGER *a, int b);
#pragma aux lladdim "lladdim" parm routine [EAX] [EDX];


void llsub(ULARGE_INTEGER *a, ULARGE_INTEGER *b);
#pragma aux llsub "llsub" parm routine [EAX] [EDX];

void llshr(ULARGE_INTEGER *a, int s);
#pragma aux llshr "llshr" parm routine [EAX] [EDX];

unsigned long int lldiv(ULARGE_INTEGER *a, unsigned long int d);
#pragma aux lldiv "lldiv" parm routine [EAX] [EDX];

void rdtsc( ULARGE_INTEGER *a );
#pragma aux rdtsc "rdtsc" parm routine [EAX];


LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK baseWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK AdjustWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ClockWndProc( HWND, UINT, WPARAM, LPARAM);

void BaseWindowInit( HWND hwnd );
void ClockWindow( HWND hwnd );
void AdjustWindowInit( HWND hwnd );

void UpdateClock( void );
HBITMAP BMPLoad( const char *filename, SIZE *sz );
void UpdateClock( void );
int DoAdjustCPU( HWND hwndParent, POINT *pt );

void StartInspeceClock( void );
void StopInspeceClock( void );
void SetCpuState( int state );

extern HANDLE vevSync;
extern RECT vRC;
extern struct LAPTIMES vLaps;
extern HWND vhwndClock;
extern HBITMAP vhBmp;
extern int vnCharSizeX;
extern int vnCharSizeY;
extern int vfAdjustable;
extern BOOL WINAPI (*pfnReadProcessorPwrScheme)(UINT,PMACHINE_PROCESSOR_POWER_POLICY);
extern BOOL WINAPI (*pfnWriteProcessorPwrScheme)(UINT,PMACHINE_PROCESSOR_POWER_POLICY);
